TwiMLTM Voice: <Sms>

The <Sms> verb sends an SMS message to a phone number during a phone call.

Verb Attributes

The <Sms> verb supports the following attributes that modify its behavior:

Attribute Name Allowed Values Default Value
to phone number see below
from phone number see below
action relative or absolute URL none
method GET, POST POST
statusCallback relative or absolute URL none

to

The 'to' attribute takes a valid phone number as a value. Twilio will send an SMS message to this number.

When sending an SMS during an incoming call, 'to' defaults to the caller. When sending an SMS during an outgoing call, 'to' defaults to the called party. The value of 'to' must be a valid phone number. NOTE: sending to short codes is
not currently supported.

Phone numbers should be formatted with a '+' and country code e.g., +16175551212 ([E.164][1] format). Twilio will also accept unformatted US numbers e.g., (415) 555-1212 or 415-555-1212.

Note that if you are sending SMS from the Twilio Sandbox Number, the provided 'to' phone number must be verified with Twilio. But of course you don't need to specify the 'to' attribute to just send an SMS to the current caller.

from

The 'from' attribute takes a valid phone number as an argument. This number must be a phone number that you've purchased from or ported to Twilio. When sending an SMS during an incoming call, 'from' defaults to the called party. When sending an SMS during an outgoing call, 'from' defaults to the calling party. This number must be an SMS-capable local phone number assigned to your account. If the phone number isn't SMS-capable, then the <Sms> verb will not send an SMS message.

action

The 'action' attribute takes a URL as an argument. After processing the <Sms> verb, Twilio will make a GET or POST request to this URL with the form parameters 'SmsStatus' and 'SmsSid'. Using an 'action' URL, your application can receive synchronous notification that the message was successfully enqueued.

If you provide an 'action' URL, Twilio will use the TwiML received in your response to the 'action' URL request to continue the current call. Any TwiML verbs occuring after an <Sms> which specifies an 'action' attribute are unreachable.

If no 'action' is provided, <Sms> will finish and Twilio will move on to the next TwiML verb in the document. If there is no next verb, Twilio will end the phone call. Note that this is different from the behavior of <Record> and <Gather>. <Sms> does not make a request to the current document's URL by default if no 'action' URL is provided.

Request Parameters

Twilio will pass the following parameters in addition to the standard TwiML Voice request parameters with its request to the 'action' URL:

Parameter Description
SmsSid The Sid Twilio has assigned for the SMS message.
SmsStatus The current status of the SMS message. This is usually 'sending'. But if you provide an invalid number, this is 'invalid'.

method

The 'method' attribute takes the value 'GET' or 'POST'. This tells Twilio whether to request the 'action' URL via HTTP GET or POST. This attribute is modeled after the HTML form 'method' attribute. 'POST' is the default value.

statusCallback

The 'statusCallback' attribute takes a URL as an argument. When the SMS message is actually sent, or if sending fails, Twilio will make an asynchronous POST request to this URL with the parameters 'SmsStatus' and 'SmsSid'. Note, 'statusCallback' always uses HTTP POST to request the given url.

Request Parameters

Twilio will pass the following parameters in addition to the standard TwiML Voice request parameters with its request to the 'statusCallback' URL:

Parameter Description
SmsSid The Sid for the Sms message
SmsStatus The current status of the Sms message. Either 'sent' or 'failed'

Nouns

The "noun" of a TwiML verb is the stuff nested within the verb that's not a verb itself; it's the stuff the verb acts upon. These are the nouns for <Sms>:

Noun Description
plain text The text of the SMS message you want to send. Must be less than 160 characters.

Nesting Rules

You can't nest any verbs within <Sms> and you can't nest <Sms> in any other verbs.

See Also

Twilio REST API SMS Messages Resource

Examples

Example 1: Simple SMS sending

This is the simplest case for <Sms>. Twilio first tells the caller where the store is located, and then sends the caller an SMS with the location as the message.

<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/simple_sms.xml -->
<Response>
    <Say>Our store is located at 123 Easy St.</Say>
    <Sms>Store Location: 123 Easy St.</Sms>
</Response>    

Example 2: SmsStatus reporting

In this use case, we provide 'action' URL and 'method' attributes. Now when the message is queued for delivery, Twilio will make a request to the 'action' URL passing the parameter 'SmsStatus'. If the messages is queued and waiting to be sent, 'SmsStatus' will have the value 'sending'. If an invalid attribute was provided, then 'SmsStatus' will be 'invalid'.

Your web application can look at the 'SmsStatus' parameter and decide what to do next.

If an 'action' URL is provided for <Sms>, flow of your application will continue with the TwiML received in response to the 'action' request. All verbs remaining in the document are unreachable and ignored.

<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/sms_status.xml -->
<Response>
    <Say>Our store is located at 123 Easy St.</Say>
    <Sms action="/smsHandler.php" method="POST">Store Location: 123 Easy St.</Sms>
</Response>

Example 3: statusCallback reporting

In this example we provide a 'statusCallback' URL. When the message is finished sending (not just enqueued), Twilio will asynchronously request the 'statusCallback' URL with the parameter 'SmsStatus'. If the messages was successfully sent, 'SmsStatus' will be 'sent'. If the message failed to send, 'SmsStatus' will be 'failed'.

<?xml version="1.0" encoding="UTF-8"?>
<!-- page located at http://example.com/sms_status_callback.xml -->
<Response>
    <Say>Our store is located at 123 Easy St.</Say>
    <Sms statusCallback="/smsHandler.php">Store Location: 123 Easy St.</Sms>
</Response>